.const

PEImgAddSectionHdr		PROTO	:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
PEImgCreate				PROTO	:DWORD,:DWORD,:DWORD
PEImgDirEntryToData		PROTO	:DWORD,:DWORD
PEImgFileAlign			PROTO	:DWORD,:DWORD
PEImgFlush				PROTO	:DWORD
PEImgFree				PROTO	:DWORD
PEImgIsRvaInSection		PROTO	:DWORD,:DWORD,:DWORD
PEImgMemAlign			PROTO	:DWORD,:DWORD
PEImgOffsetToRva		PROTO	:DWORD,:DWORD
PEImgReload				PROTO	:DWORD
PEImgRelocate			PROTO	:DWORD,:DWORD
PEImgRvaToOffset		PROTO	:DWORD,:DWORD
PEImgSectionType		PROTO	:DWORD,:DWORD
PEImgSetChecksum		PROTO	:DWORD
PEImgVa					PROTO	:DWORD,:DWORD


; IMAGE_DIRECTORY_ENTRY_* AS FLAGS IN DWORD

OBJ_DONTCARE equ 0
OBJ_EXPORT equ (1 shl IMAGE_DIRECTORY_ENTRY_EXPORT) 
;IMAGE_DIRECTORY_ENTRY_EXPORT				equ  0
OBJ_IMPORT equ (1 shl IMAGE_DIRECTORY_ENTRY_IMPORT)
;IMAGE_DIRECTORY_ENTRY_IMPORT				equ  1
OBJ_RESOURCE equ (1 shl IMAGE_DIRECTORY_ENTRY_RESOURCE)
;IMAGE_DIRECTORY_ENTRY_RESOURCE				equ  2
OBJ_EXCEPTION equ (1 shl IMAGE_DIRECTORY_ENTRY_EXCEPTION)
;IMAGE_DIRECTORY_ENTRY_EXCEPTION			equ  3
OBJ_SECURITY equ (1 shl IMAGE_DIRECTORY_ENTRY_SECURITY)
;IMAGE_DIRECTORY_ENTRY_SECURITY				equ  4
OBJ_BASERELOC equ (1 shl IMAGE_DIRECTORY_ENTRY_BASERELOC)
;IMAGE_DIRECTORY_ENTRY_BASERELOC			equ  5
OBJ_DEBUG equ (1 shl IMAGE_DIRECTORY_ENTRY_DEBUG)
;IMAGE_DIRECTORY_ENTRY_DEBUG				equ  6
OBJ_COPYRIGHT equ (1 shl IMAGE_DIRECTORY_ENTRY_COPYRIGHT)
;IMAGE_DIRECTORY_ENTRY_COPYRIGHT			equ  7
OBJ_ARCHITECTURE equ (1 shl IMAGE_DIRECTORY_ENTRY_ARCHITECTURE)
;IMAGE_DIRECTORY_ENTRY_ARCHITECTURE			equ  7
OBJ_GLOBALPTR equ (1 shl IMAGE_DIRECTORY_ENTRY_GLOBALPTR)
;IMAGE_DIRECTORY_ENTRY_GLOBALPTR			equ  8
OBJ_TLS equ (1 shl IMAGE_DIRECTORY_ENTRY_TLS)
;IMAGE_DIRECTORY_ENTRY_TLS					equ  9
OBJ_LOAD_CONFIG equ (1 shl IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG)
;IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG			equ 10
OBJ_BOUND_IMPORT equ (1 shl IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT)
;IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT			equ 11
OBJ_IAT equ (1 shl IMAGE_DIRECTORY_ENTRY_IAT)
;IMAGE_DIRECTORY_ENTRY_IAT					equ 12
OBJ_DELAY_IMPORT equ (1 shl IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT)
;IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT			equ 13   
OBJ_COM_DESCRIPTOR equ (1 shl IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR)
;IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR		equ 14
OBJ_RESERVED equ (1 shl IMAGE_DIRECTORY_ENTRY_RESERVED)
;RESERVED									equ 15
;IMAGE_NUMBEROF_DIRECTORY_ENTRIES			equ 16

.const

PEIMAGE struct
	hFile       DWORD ?
	dwFsize     DWORD ?
	UNION
	pMem        DWORD ?
	pDos        DWORD ?
	ENDS
	pNt         DWORD ?
	pFirstSec   DWORD ?
	ImageBase   DWORD ?
	SecNum      DWORD ?
	SizeOfImage DWORD ?
	Flags       DWORD ?
	pExeName    DWORD ?
;	pOverlay    DWORD ?
PEIMAGE ends

pefReadOnly equ 1b

SECTION_ALIGN equ 1000h

;END INCLUDE FILE

AlignTo macro Reg:req,iAlign:req
	add Reg,iAlign-1
	and Reg,-iAlign
endm

PEImgLastSec macro ptrpe:req
	mov eax,[ptrpe].PEIMAGE.pFirstSec
	mov ecx,[ptrpe].PEIMAGE.SecNum
	imul ecx,ecx,sizeof IMAGE_SECTION_HEADER
	lea eax,[eax+ecx-sizeof IMAGE_SECTION_HEADER]
endm

.code

PEImgCreate proc uses esi edi pImg,szFileName,bReadOnly
	assume esi:ptr PEIMAGE
	mov esi,pImg
	mov ecx,GENERIC_READ
	mov edx,pefReadOnly
	.if !bReadOnly
		or ecx,GENERIC_WRITE
		xor edx,edx
	.endif
	mov [esi].Flags,edx
	invoke CreateFile,szFileName,ecx,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
	mov [esi].hFile,eax
	xor ecx,ecx
	cmp eax,INVALID_HANDLE_VALUE
	jz @@Err1
	invoke StrLen,szFileName
	inc eax
	invoke GetMem,eax
	mov edi,eax
	invoke StrCpy,edi,szFileName
	mov [esi].pExeName,edi
	invoke GetFileSize,[esi].hFile,0
	mov [esi].dwFsize,eax
	xor ecx,ecx
	test eax,eax
	jz @@Err2
	invoke GetVMem,[esi].dwFsize
	mov [esi].pMem,eax;	mov [esi].pDos,eax
	test eax,eax
	jz @@Err2
	push edx
	mov edx,esp
	invoke ReadFile,[esi].hFile,[esi].pMem,[esi].dwFsize,edx,0
	pop edx
	mov edx,[esi].pDos
	mov eax,edx
	add edx,[edx].IMAGE_DOS_HEADER.e_lfanew
	mov [esi].pNt,edx
	cmp [eax].IMAGE_DOS_HEADER.e_magic,IMAGE_DOS_SIGNATURE
	jnz @@Err3
	cmp [edx].IMAGE_NT_HEADERS.Signature,IMAGE_NT_SIGNATURE
	jnz @@Err3
	movzx ecx,[edx].IMAGE_NT_HEADERS.FileHeader.NumberOfSections
	mov [esi].SecNum,ecx
	lea eax,[edx+SIZEOF IMAGE_NT_HEADERS]
	mov [esi].pFirstSec,eax
	mov ecx,[edx].IMAGE_NT_HEADERS.OptionalHeader.ImageBase
	mov eax,[edx].IMAGE_NT_HEADERS.OptionalHeader.SizeOfImage
	mov [esi].ImageBase,ecx
	mov [esi].SizeOfImage,eax
	mov eax,TRUE
	ret
@@Err3:
	invoke FreeVMem,[esi].pMem
@@Err2:
	invoke CloseHandle,[esi].hFile
@@Err1:
	xor eax,eax;FALSE
	ret
	assume esi:nothing
PEImgCreate endp

PEImgFree proc uses esi pImg
	assume esi:ptr PEIMAGE
	mov esi,pImg
	.if [esi].pMem
		invoke FreeVMem,[esi].pMem
	.endif
	.if [esi].hFile != INVALID_HANDLE_VALUE
		invoke CloseHandle,[esi].hFile
	.endif
	.if [esi].pExeName
		invoke FreeMem,[esi].pExeName
	.endif
	assume esi:nothing
	ret
PEImgFree endp

PEImgReload proc uses esi edi ebx pImg
	assume esi:ptr PEIMAGE
	mov esi,pImg
	invoke StrLen,[esi].pExeName
	inc eax
	invoke GetMem,eax
	mov edi,eax
	invoke StrCpy,edi,[esi].pExeName
	xor ebx,ebx
	test [esi].Flags,pefReadOnly
	setnz bl
	invoke PEImgFree,pImg
	invoke PEImgCreate,pImg,edi,ebx
	invoke FreeMem,edi
	assume esi:nothing
	ret
PEImgReload endp

PEImgFlush proc uses esi pImg
LOCAL nbw
	assume esi:ptr PEIMAGE
	mov esi,pImg
	xor eax,eax;FALSE
	.if !([esi].Flags & pefReadOnly)
		invoke SetFilePointer,[esi].hFile,0,0,FILE_BEGIN
		invoke WriteFile,[esi].hFile,[esi].pMem,[esi].dwFsize,addr nbw,0
		mov eax,TRUE
	.endif
	ret
	assume esi:nothing
PEImgFlush endp

PEImgSetChecksum proc uses esi pImg;eax:edx new_csum:old_csum
	assume esi:ptr PEIMAGE
	mov esi,pImg
	mov edx,[esi].pNt
	xor eax,eax
	push [edx].IMAGE_NT_HEADERS.OptionalHeader.CheckSum
	mov [edx].IMAGE_NT_HEADERS.OptionalHeader.CheckSum,eax
	mov ecx,[esi].dwFsize; buffer length
	mov edx,[esi].pDos; edx is pointer to our buffer base
	shr ecx,1; we're summing WORDs, not bytes
	xor eax,eax; EAX holds the checksum	clc; Clear the carry flag ready for later...
	.repeat
		adc ax,[edx+ecx*2-2]
		dec ecx
	.until zero?
	adc eax,[esi].dwFsize
	mov edx,[esi].pNt
	mov [edx].IMAGE_NT_HEADERS.OptionalHeader.CheckSum,eax
	pop edx
	ret
	assume esi:nothing
PEImgSetChecksum endp

PEImgFileAlign proc uses esi pImg,dwValue
	assume esi:ptr PEIMAGE
	mov esi,pImg
	mov ecx,[esi].pNt
	mov eax,dwValue
	mov ecx,[ecx].IMAGE_NT_HEADERS.OptionalHeader.FileAlignment
	dec eax
	dec ecx
	or eax,ecx
	inc eax
	ret	
	assume esi:nothing
PEImgFileAlign endp

PEImgMemAlign proc uses esi pImg,dwValue
	assume esi:ptr PEIMAGE
	mov esi,pImg
	mov ecx,[esi].pNt
	mov eax,dwValue
	mov ecx,[ecx].IMAGE_NT_HEADERS.OptionalHeader.SectionAlignment
	dec eax
	dec ecx
	or eax,ecx
	inc eax
	ret	
	assume esi:nothing
PEImgMemAlign endp

PEImgRvaToOffset proc uses esi pImg,RVA
	assume esi:ptr PEIMAGE
	assume ecx:ptr IMAGE_SECTION_HEADER
	mov esi,pImg
	mov ecx,[esi].PEIMAGE.pFirstSec
	mov eax,[esi].PEIMAGE.SecNum
	.repeat
		mov edx,[ecx].VirtualAddress
		.if edx <= RVA
			add edx,[ecx].SizeOfRawData
			.if edx > RVA
				mov	eax,[ecx].PointerToRawData
				add eax,RVA
				sub eax,[ecx].VirtualAddress
				ret
			.endif
		.endif    
		add ecx,SIZEOF IMAGE_SECTION_HEADER
		dec eax
	.until ZERO?
	ret
	assume ecx:nothing
	assume esi:nothing
PEImgRvaToOffset endp

PEImgOffsetToRva proc uses esi pImg,Offs
	assume esi:ptr PEIMAGE
	assume ecx:ptr IMAGE_SECTION_HEADER
	mov esi,pImg
	mov ecx,[esi].PEIMAGE.pFirstSec
	mov eax,[esi].PEIMAGE.SecNum
	.repeat
		mov edx,[ecx].PointerToRawData
		.if edx <= Offs
			add edx,[ecx].Misc.VirtualSize;  ..VirtualSize
			.if edx > Offs
				mov eax,[ecx].VirtualAddress
				sub eax,[ecx].PointerToRawData
				add eax,Offs
				ret
			.endif
		.endif    
		add ecx,Sizeof IMAGE_SECTION_HEADER
		dec eax
	.until ZERO?
	ret
	assume ecx:nothing
	assume esi:nothing
PEImgOffsetToRva endp

PEImgVa proc uses esi pImg,RVA; wrapp
	assume esi:ptr PEIMAGE
	mov esi,pImg
	invoke PEImgRvaToOffset,pImg,RVA
	add eax,[esi].pMem
	ret
	assume esi:nothing
PEImgVa endp

PEImgVaToRva proc uses esi pImg,VA;;reverse
	assume esi:ptr PEIMAGE
	mov esi,pImg
	mov eax,VA
	sub eax,[esi].pMem
	invoke PEImgOffsetToRva,pImg,eax
	ret
	assume esi:nothing
PEImgVaToRva endp

PEImgDirEntryToData proc uses esi pImg,DirectoryEntry;eax:edx ptr:size
	assume esi:ptr PEIMAGE
	mov esi,pImg
	mov edx,[esi].pNt
	mov ecx,DirectoryEntry
	imul ecx,ecx,(sizeof IMAGE_DATA_DIRECTORY)
	mov eax,[edx].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[ecx].VirtualAddress
	push [edx].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[ecx].isize
	.if eax
		invoke PEImgVa,pImg,eax
	.endif
	pop edx
	ret
	assume esi:nothing
PEImgDirEntryToData endp

PEImgIsRvaInSection proc uses esi pImg,RVA,iSection
	assume esi:ptr PEIMAGE
	mov esi,pImg
	mov ecx,[esi].PEIMAGE.pFirstSec
	mov eax,[esi].PEIMAGE.SecNum
	mov edx,iSection; 1,2,3,...,SecNum
	.if edx <= eax
		imul edx,SIZEOF IMAGE_SECTION_HEADER
		lea ecx,[ecx+edx-SIZEOF IMAGE_SECTION_HEADER]
		mov edx,[ecx].IMAGE_SECTION_HEADER.VirtualAddress
		.if edx <= RVA
			if 1
			add edx,[ecx].IMAGE_SECTION_HEADER.Misc.VirtualSize
			else
			mov eax,[ecx].IMAGE_SECTION_HEADER.Misc.VirtualSize
			AlignTo eax,SECTION_ALIGN
			add edx,eax
			endif
			.if edx > RVA
				mov	eax,TRUE
				ret
			.endif
		.endif    
	.endif
	xor eax,eax
	ret
	assume esi:nothing
PEImgIsRvaInSection endp

PEImgAddSectionHdr proc uses esi edi ebx pImg,SecName,VSize,RSize,dwSecFlags
	assume ebx:ptr PEIMAGE,edi:ptr IMAGE_NT_HEADERS,esi:ptr IMAGE_SECTION_HEADER;first
	mov ebx,pImg
	mov edi,[ebx].pNt
	mov esi,[ebx].pFirstSec
	mov ecx,[ebx].SecNum
	imul ecx,sizeof IMAGE_SECTION_HEADER
	
	mov edx,esi
	sub edx,[ebx].pDos; size til 1st sec hdr
	add edx,ecx; size til new sec hdr 
	add edx,sizeof IMAGE_SECTION_HEADER; right after new sec
	
	mov ebx,esi
	add ebx,ecx; ptr new sec
	
	assume ebx:ptr IMAGE_SECTION_HEADER
	mov eax,[esi].PointerToRawData
	lea esi,[ebx-sizeof IMAGE_SECTION_HEADER];previous
	.if edx <= eax ; edx is beyond raw data
		inc [edi].FileHeader.NumberOfSections
		mov eax,pImg
		inc [eax].PEIMAGE.SecNum
		mov eax,SecName
		.if eax
			mov ecx,[eax][0]
			mov edx,[eax][4]
		.else
			xor ecx,ecx
			xor edx,edx
		.endif
		mov dword ptr [ebx].Name1[0],ecx
		mov dword ptr [ebx].Name1[4],edx
		
		invoke PEImgMemAlign,pImg,VSize
		mov [ebx].Misc.VirtualSize,eax
		
		invoke PEImgFileAlign,pImg,RSize
		mov [ebx].SizeOfRawData,eax
		
		mov eax,[esi].VirtualAddress
		add eax,[esi].Misc.VirtualSize
		invoke PEImgMemAlign,pImg,eax
		mov [ebx].VirtualAddress,eax
		
		mov eax,[esi].PointerToRawData
		add eax,[esi].SizeOfRawData
		invoke PEImgFileAlign,pImg,eax
		mov [ebx].PointerToRawData,eax
		
		m2m [ebx].Characteristics,dwSecFlags
		mov eax,[ebx].VirtualAddress
		add eax,[ebx].Misc.VirtualSize
		mov [edi].OptionalHeader.SizeOfImage,eax
		mov eax,TRUE
	.else
		xor eax,eax
	.endif
	assume ebx:nothing,esi:nothing,edi:nothing
	ret
PEImgAddSectionHdr endp

PEImgSectionType proc uses esi edi ebx pImg,iSection
	xor ebx,ebx
	xor edi,edi ; OBJ_DONTCARE 
	mov esi,pImg
	mov esi,[esi].PEIMAGE.pNt
	.repeat
		;DirEntryToData
		imul ecx,ebx,sizeof IMAGE_DATA_DIRECTORY
		mov eax,[esi].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[ecx].VirtualAddress
		.if eax
			invoke PEImgIsRvaInSection,pImg,eax,iSection
			mov ecx,ebx
			shl eax,cl
			or edi,eax; OBJ_*
		.endif
		inc ebx
	.until ebx == IMAGE_NUMBEROF_DIRECTORY_ENTRIES
	mov eax,edi; OBJ_*
	ret
PEImgSectionType endp

PEImgRelocate proc uses ebx edi esi pImg,NewBase
LOCAL DeltaBase,Chunks
	assume esi:ptr PEIMAGE
	mov esi,pImg
	mov eax,NewBase
	sub eax,[esi].PEIMAGE.ImageBase
	.if !zero?; if zero then no need to relocate
		mov DeltaBase,eax
		invoke PEImgDirEntryToData,pImg,IMAGE_DIRECTORY_ENTRY_BASERELOC
		mov esi,eax
		assume ebx:ptr IMAGE_BASE_RELOCATION
		.if eax
			.while [ebx].VirtualAddress != 0
				mov ecx,[ebx].SizeOfBlock
				sub ecx,sizeof IMAGE_BASE_RELOCATION
				shr ecx,1;('SizeOfBlock'-sizeof(IMAGE_BASE_RELOCATION))/2
				lea edi,[ebx+sizeof IMAGE_BASE_RELOCATION]
				mov Chunks,ecx
				.while ecx
					movzx eax,word ptr [edi]
					dec ecx
					add edi,2
					mov Chunks,ecx
					.if eax & (IMAGE_REL_BASED_HIGHLOW shl 12); test 4 bits of flags
						and eax,111111111111b ; mask 12 bits of position
						add eax,[ebx].VirtualAddress
						invoke PEImgVa,pImg,eax
						mov edx,DeltaBase
						add [eax],edx
					.endif
					mov ecx,Chunks
				.endw
				mov ebx,edi
			.endw
			mov eax,TRUE
		.endif
		assume ebx:nothing
	.endif
	ret
	assume esi:nothing
PEImgRelocate endp

.code
;GetVirtualSum proc pPeImg:dword
;	mov eax,pPeImg
;	mov edx,[eax].PEIMAGE.pFirstSec
;	mov eax,[eax].PEIMAGE.SizeOfImage
;	sub eax,[edx].IMAGE_SECTION_HEADER.VirtualAddress
;	ret
;GetVirtualSum endp
;
;GetRawSum proc pPeImg:dword
;	mov eax,pPeImg
;	mov ecx,[eax].PEIMAGE.SecNum
;	mov edx,[eax].PEIMAGE.pFirstSec
;	xor eax,eax
;	.repeat
;		add eax,[edx].IMAGE_SECTION_HEADER.SizeOfRawData
;		add edx,sizeof IMAGE_SECTION_HEADER
;		dec ecx
;	.until ZERO?
;	ret
;GetRawSum endp
;
;RelocImportTable proc uses esi edi ebx pPeImg:dword,NewRva:dword,DeltaRva:dword
;	invoke DirEntryToData,pPeImg,ENTRY_IMPORT
;	mov esi,eax;	mov ebx,edx
;	.if eax
;		assume esi:ptr IMAGE_IMPORT_DESCRIPTOR,edi:ptr IMAGE_THUNK_DATA	
;		.while [esi].FirstThunk
;			mov ecx,NewRva
;			mov edx,[esi].FirstThunk
;			mov ebx,[esi].OriginalFirstThunk; take the originals first
;			add [esi].FirstThunk,ecx
;			.if ebx != 0; actually not need unless i change compiler of my dll
;				add [esi].OriginalFirstThunk,ecx
;			.endif
;			add [esi].Name1,ecx
;			invoke RvaToPEImage,pPeImg,edx; reloc FirstThunk
;			mov ecx,NewRva
;			mov edi,eax
;			.while [edi].u1.AddressOfData; i dont expect any Ordinal here !!!
;				add [edi].u1.AddressOfData,ecx
;				add edi,4
;			.endw 
;			.if ebx != 0; actually not need unless i change compiler of my dll
;				invoke RvaToPEImage,pPeImg,ebx; reloc OriginalFirstThunk
;				mov ecx,DeltaRva
;				mov edi,eax
;				.while [edi].u1.AddressOfData; i dont expect any Ordinal here !!!
;					add [edi].u1.AddressOfData,ecx
;					add edi,4
;				.endw
;			.endif 
;			add esi,sizeof IMAGE_IMPORT_DESCRIPTOR
;		.endw
;		mov eax,TRUE
;	.endif
;	assume esi:nothing,edi:nothing
;	ret
;RelocImportTable endp
;

